unit main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, Buttons, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    BitBtn1: TBitBtn;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    BitBtn2: TBitBtn;
    Image1: TImage;
    Button5: TButton;
    Button11: TButton;
    Button6: TButton;
    Button7: TButton;
    Button8: TButton;
    Button9: TButton;
    Button10: TButton;
    Edit1: TEdit;
    TabControl1: TTabControl;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Memo1: TMemo;
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
    procedure Button8Click(Sender: TObject);
    procedure Button9Click(Sender: TObject);
    procedure Button10Click(Sender: TObject);
    procedure Button11Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Edit1Change(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TabControl1Change(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

type tab = array [1..10] of TColor;
var t : tab;

implementation
  uses frmhelpp,frmoprogram,ugraf,usoubor, novy , umetody, nv, frmedvrch, ukontrola,
   uvykresli ,frminfo ;
{$R *.DFM}
   var i:integer;

procedure tabulka;
begin
t[1]:=clMaroon;
t[2]:=clGreen ;
t[3]:=clOlive  ;

t[4]:=clBlue     ;
t[5]:=clNavy      ;
t[6]:=clTeal       ;

t[7]:=clPurple       ;
t[8]:=clGray          ;
t[9]:=clBlack          ;

t[10]:=clRed             ;



end;




procedure TForm1.BitBtn1Click(Sender: TObject);
begin
if pr <> nil then
begin
dispose(pr);
graf.grdis;
pr := nil;
end;
Close;
end;

procedure obarvi;
var i : byte;
begin
for i:=1 to graf.vvrcholu do
begin
tk.vrchol(graf.gvx(i),graf.gvy(i),t[i]);
end;
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
    Form7.Show;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
 Form6.Show;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   OpenDialog1 := TOpenDialog.Create(self);
   OpenDialog1.InitialDir := GetCurrentDir;
    if OpenDialog1.Execute then
  begin
    // Display the selected file names
      if graf.vvrcholu > 0 then zmasgraf;
      zmensoubor(OpenDialog1.FileName);
      i := nactigraf;
      if i = 0 then
             begin
               Edit1.Text:=vydejsoubor;
               TabControl1.Visible:=True;
{               tkgr.kresligraf(clBlue,clRed);  }
               {Close;}
             end
             else
             begin
               TabControl1.Visible:=False;
               Button3.Visible:=False;
               if i= 1 then Showmessage ( ' vami vybrany soubor obsahuje data negrafu ' )
                 else
                   begin
                     Showmessage ( ' vami vybrany soubor neexistuje ' );
                   end;
             end;
  end;

  // Free up the dialog
  OpenDialog1.Free;
  tkgr.kresligraf(clBlack,clBlack);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
  saveDialog1 := TSaveDialog.Create(self);

  // Give the dialog a title
  saveDialog1.Title := 'Zadejte adresu souboru ve kterem bude graf ulozen';

  // Set up the starting directory to be the current one
  saveDialog1.InitialDir := GetCurrentDir;

  // Allow only .txt and .doc file types to be saved


  // Set the default extension
  saveDialog1.DefaultExt := 'grf';

  // Select text files as the starting filter type

  // Display the open file dialog
  if saveDialog1.Execute
  then
   begin
    zmensoubor (SaveDialog1.FileName) ;
    Form1.Edit1.Text:=saveDialog1.FileName;
    vypisgraf;
    tkgr.kresligraf(clBlack,clBlack);
   end;
   {Close;}
 // Free up the dialog
  saveDialog1.Free;
  Edit1Change(Sender);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
Form3.Show;
end;

procedure TForm1.Button6Click(Sender: TObject);
begin
pr^.but6;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
pr^.but7 ;
end;

procedure TForm1.Button8Click(Sender: TObject);
begin
  pr^.but8;
end;

procedure TForm1.Button9Click(Sender: TObject);
begin
  obarvi;
  form2.show;
end;


procedure TForm1.Button10Click(Sender: TObject);
begin
  obarvi;
end;
                                  


procedure TForm1.Button11Click(Sender: TObject);
begin
  FormXY.Show;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
  Form4.Show;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
dispose(pr);
graf.grdis;
end;

procedure TForm1.Edit1Change(Sender: TObject);
begin
if (( FileExist(Edit1.Text) ) and ( kontrols(Edit1.text))) then
  begin
  TabControl1.Visible:=True;
  Button5.Visible := True;
  Button11.Visible := True;
  Button3.visible := True;
  Button9.visible := True;
  Button10.visible := True;
  tkgr.kresligraf(clSilver,clSilver);
  end
  else
  begin
  tk.vytvor;
  TabControl1.Visible:=False;
  Button5.Visible := False;
  Button11.Visible := False;
  Button3.visible := False;
  Button9.visible := False;
  Button10.visible := False;
  end ;

end;


procedure TForm1.FormShow(Sender: TObject);
begin
 tabulka;
 Image1.Canvas.Create;
 tk.vytvor;
 pr :=nil;
end;

procedure TForm1.TabControl1Change(Sender: TObject);
begin
tabulka;
 if ( Edit1.Text <> 'Zadny graf otevren') and ( kontrols(Edit1.text)) then
   begin
     if ( TabControl1.Tabindex = 0 )then          { VyberGrafu }
                            begin
                             Button5.Visible := True;
                             {BitBtn1.Visible := True;
                             BitBtn2.Visible := True; }
                             Button1.Visible := True;
                             Button2.Visible := True;
                             Button3.Visible := True;
                             {Button4.Visible := True;  }
                             Button6.Visible := False;
                             Button7.Visible := False;
                             Button8.Visible := False;
                             Button9.Visible := True;
                             Button10.Visible := True;
                             Button11.Visible := True;
                             Memo1.Visible := False;
                             Image1.Visible := True;
                             if pr<>nil then Dispose (pr);
                             pr:=nil;
                             tk.vytvor;
                             tkgr.kresligraf(clBlack,clBlack);
                           end
                      else begin                    { Ostatni }
                             Button5.Visible := False;
                             {BitBtn1.Visible := True;
                             BitBtn2.Visible := True; }
                             Button1.Visible := False;
                             Button2.Visible := False;
                             Button3.Visible := False;
                             {Button4.Visible := True;  }
                             Button6.Visible := True;
                             Button7.Visible := True;
                             Button8.Visible := True;
                             Button10.Visible := True;
                             Button11.Visible := False;
                             Button9.Visible := True;
                             if pr<>nil then
                              begin
                              Dispose (pr);
                              pr:=nil;
                              end;
                           end ;
  if ( TabControl1.Tabindex = 1 )then               { Najdi }
                           begin
                             Button6.Caption := ' Skore ';
                             Button7.Caption := ' Nejkratsi kostra ';
                             Button8.Caption := ' K - Souvislost ';
//                             Button9.caption := ' Nejkratsi cesta ' ;
                             Button8.Visible := False;
//                             Button10.Visible := False;
                             pr:=New(PMPocet,CPocet);
                             pr^.but7;
                             dispose(pr);
                             pr:=nil;
                             Memo1.Visible := True;
                             Memo1.Text:='';
                             Image1.Visible := True;
                             tk.vytvor;
                             tkgr.kresligraf(clBlack,clBlack);
                             pr:=New(PMNajdi,CNajdi);
                           end ;
  if ( TabControl1.Tabindex = 2 )then             { Simulace }
                           begin
                             Button6.caption := ' Kruskal ';
                             Button7.caption := ' Jarnik ';
                             Button8.caption := ' Boruvka';
      //                       Button9.caption := ' Dijkstra ' ;
      //                       Button10.Visible := True;
      //                       Button10.caption := ' Barvici ' ;
                             Memo1.Visible := True;
                             Image1.Visible := True;
                             pr:=New(PMPocet,CPocet);
                             pr^.but7;
                             dispose(pr);
                             Memo1.Text := '';
                             pr:=nil;
                             tk.vytvor;
                             tkgr.kresligraf(clBlack,clBlack);
                             pr:=New(PMSimul,CSimul);
                           end ;
  if ( TabControl1.Tabindex = 3 )then             { Pocet }
                           begin
                             Button6.caption := ' Koster ';
                             Button7.caption := ' Komponent ';
                             Button8.caption := ' Barev ';
                             Button8.visible := false;
    //                         Button9.caption := ' Jednotazek ' ;
    //                         Button9.Visible := False;
    //                         Button10.Visible := False;
                             Memo1.Visible := True;
                             Memo1.Text:='';
                             Image1.Visible := True;
                             pr:=New(PMPocet,CPocet);
                           end ;
  end;

end;

end.
