unit USoubor;

interface
uses
    UGraf;


function vydejsoubor:string;  { Funkce vrati adresu souboru grafu }
function nactigraf:byte;        { funkce nacte graf }
function vypisgraf:byte;         { funkce ulozi graf }
procedure zmensoubor(s:string);  { Funkce nastavi s jako adresu souboru grafu }
function zmasgraf:byte;           { funkce zmaze graf }
Function FileExist(FN :string) :Boolean;{ funkce kontroly existence souboru FN }

implementation
   uses Sysutils,ukontrola;

   var f:text;
   var soub:string;


Function FileExist(FN :string) :Boolean;
Begin
 FileExist:= FileExists(FN);
End;



procedure zmensoubor(s:string);
   begin
     soub:=s;
   end;


function vydejsoubor:string;
    begin
       vydejsoubor := soub;
    end;

function nactigraf:byte;
{ funkce nacte graf
         navratove hodnoty : 0 - nacteni probehlo v poradku
                             1 - soubor neni formatem grafu
                             2 - soubor neexistuje }
     var x:byte;
         y:integer;
         z:real;
         i,j:byte;
         s:string;
         {c:char;}
   begin
      assign (f,soub);
      if FileExist(soub) then
      begin
      if (kontrols(soub)) then
      begin
      reset(f);
      read(f,x);
       graf.grcreate(x); { vytvoreni grafu s x vrcholy }
      for i:=1 to x do
            begin
              { nacitani udaju jednotlivych vrcholu }
            read(f,z);
            graf.gzho(i,z);
            read(f,y);
            graf.gzx(i,y);
            read(f,y);
            graf.gzy(i,y);
            for j:=1 to x do
                 begin
                   { nacitani jednotlivych hran }
                  read(f,z);
                  graf.gzsou(i,j,z);
                 end;
            read (f,s);
            graf.gzjm(i,s);
            end;
      Close (f);       { Uzavreni souboru a spravne nastaveni navratove hodnoty }
      nactigraf:=0;
      end
      else
      begin
      nactigraf:=1;
      end;
      end
      else
      begin
       nactigraf:=2;
      end;
  end;

function vypisgraf:byte;
{ Funkce vypise graf do globalne nastaveneho souboru ( soukroma promena tohoto unitu )
   Navratove hodnoty :  0 - kdykoliv }
     var x:byte;
         y:integer;
         z:real;
         i,j:byte;
         s:string;
begin
    assign (f,soub);
    rewrite(f);
    x:=graf.vvrcholu;
    writeln(f,x);
      { pocet vrcholu }
{      write(f,' ');}
      for i:=1 to x do
            begin
             { jednotlive vtcholy }
            z:=graf.gvho(i);
            write(f,z);
      	    write(f,' ');          { hodnota vrcholu , x,y }
            y:=graf.gvx(i);
            write(f,y);
      	    write(f,' ');
            y:=graf.gvy(i);
            write(f,y);
      	    write(f,' ');
            for j:=1 to x do
                 begin
                   { jednotlive hrany vedouci z vrcholu i }
                  z:=graf.gvsou(i,j);
                  write(f,z);
      		  write(f,' ');
                 end;
            s:=graf.gvjm(i);
            write (f,s);
            { Retezec komentare k vercholu }
            write(f,#13,#10);
            { Enter dodrzujici citelnost souboru ve kterych je graf ulozen }
            end;
Close (f);
vypisgraf:=0;
{ Uzavreni souboru a prirazeni navratove hodnoty }
end;

function zmasgraf:byte;
{ korekni smazani grafu , navratova hodnota je vzdy 0 }
begin
graf.grdis;
zmasgraf:=0;
end;

end.

