unit UVykresli;

interface
uses
    main,Graphics,Dialogs;

type Tkresli = object
              procedure vytvor;
              procedure vrchol (x,y:integer;c:Tcolor);
              procedure hrana (x1,y1,x2,y2:integer;c:Tcolor);
              end;
var tk:tkresli;

type Tkresligraf = object ( Tkresli )
                   procedure kresligraf( vc,hc :TColor);
                   end;

type TTabColor = array [ 0 .. 11 ] of TColor;

var tkgr:tkresligraf;
    tabc:TTabColor;
implementation
uses ugraf;

procedure tabulka;
    begin
      tabc[0] := clBlack;
      tabc[2] := clTeal;
      tabc[8] := clMaroon;
      tabc[3] := clGreen;
      tabc[4] := clYellow;
      tabc[1] := clPurple;
      tabc[6] := clGray;
      tabc[7] := clOlive;
      tabc[5] := clNavy;
      tabc[9] := clRed;
      tabc[10] := clSilver;
      tabc[11] := clBlue;
    end;
procedure Tkresli.vytvor;
begin
    tabulka;
   Form1.Image1.Canvas.Pen.Color := clGray;  
   Form1.Image1.Canvas.Brush.Color := clWhite;
   Form1.Image1.Canvas.rectangle(0,0,Form1.Image1.width,Form1.Image1.height)  ;
   Form1.Image1.Canvas.Brush.Color:=clBlack;
end;

procedure Tkresli.vrchol (x,y:integer; c:Tcolor);
begin
  Form1.Image1.Canvas.Brush.Color:=c;
  Form1.Image1.Canvas.Pen.Color:=c;
  Form1.Image1.Canvas.Ellipse(x-2,y-2,x+2,y+2);
end;

procedure Tkresli.hrana (x1,y1,x2,y2:integer; c:TColor);
begin

   Form1.Image1.Canvas.Pen.Color:=c;
  Form1.Image1.Canvas.Brush.Color:=c;
   Form1.Image1.Canvas.MoveTo(x1,y1);
   Form1.Image1.Canvas.LineTo(x2,y2);

end;

procedure Tkresligraf.kresligraf(vc,hc:TColor);
var i,j,n:byte;
begin
    inherited vytvor;
    n:=graf.vvrcholu;
    for i:=1 to n do
      begin
        for j:=i+1 to n do
        if (graf.gvsou(j,i) <> 0 ) then
       inherited hrana(graf.gvx(i),graf.gvy(i),graf.gvx(j),graf.gvy(j),hc);
       inherited vrchol(graf.gvx(i),graf.gvy(i),vc );
      end;
end;

end.

